%define _unpackaged_files_terminate_build 0
%define peardir /usr/share/php/pear
%define cliopt -d safe_mode_exec_dir=""

%define xmlrpcver  1.5.4
%define getoptver  1.3.1
%define arctarver  1.3.7
%define structver  1.0.4
%define xmlutil    1.2.1
%define esystemver 1.0.1
%define efilever   1.0.1
%define ogetoptver 1.0.0

Summary: PHP Extension and Application Repository framework
Summary(ko): PHP 확장및 응용 프로그램 저장소 프레임웍
Name: php-pear
Version: 1.9.2
Release: 3.fc16%{?dist}
Epoch: 203
# PEAR, Archive_Tar, XML_Util are BSD
# XML-RPC, Console_Getopt are PHP
# Structures_Graph is LGPLv2+
License: BSD and PHP and LGPLv2+
Group: Development/Languages
URL: http://pear.php.net/package/PEAR
Source0: http://download.pear.php.net/package/PEAR-%{version}.tgz
# wget 'http://svn.php.net/viewvc/pear/pear-core/trunk/install-pear.php?revision=308763&view=co' -O install-pear.php
# see http://pear.php.net/bugs/18367 - doc_dir relocation
Source1: install-pear.php
Source2: relocate.php
Source3: strip.php
Source4: LICENSE-XML_RPC
Source10: pear.sh
Source11: pecl.sh
Source12: peardev.sh
Source13: macros.pear
Source20: http://pear.php.net/get/XML_RPC-%{xmlrpcver}.tgz
Source21: http://pear.php.net/get/Archive_Tar-%{arctarver}.tgz
Source22: http://pear.php.net/get/Console_Getopt-%{getoptver}.tgz
Source23: http://pear.php.net/get/Structures_Graph-%{structver}.tgz
Source24: http://pear.php.net/get/XML_Util-%{xmlutil}.tgz

# thrid party
Source100: http://mirror.oops.org/pub/oops/php/pear/eSystem-%{esystemver}.tgz
Source101: http://ftp.oops.org/pub/oops/php/pear/eFilesystem/eFilesystem-%{efilever}.tgz
Source102: http://ftp.oops.org/pub/oops/php/pear/oGetopt/oGetopt-%{ogetoptver}.tgz
Source103: http://pear.php.net/get/Net_Socket-1.0.10.tgz
Source104: http://pear.php.net/get/Auth_SASL-1.0.4.tgz
Source105: http://pear.php.net/get/DB-1.7.13.tgz
Source106: http://pear.php.net/get/HTTP-1.4.1.tgz
Source107: http://pear.php.net/get/Net_SMTP-1.5.2.tgz
Source108: http://pear.php.net/get/Mail-1.2.0.tgz
Source109: http://pear.php.net/get/Net_UserAgent_Detect-2.5.2.tgz
Source110: http://pear.php.net/get/XML_Parser-1.3.4.tgz
Source111: http://pear.php.net/get/DB_DataObject-1.9.5.tgz

Source10000: AliasFunc.php

Patch0: pear-alias-func.patch

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: php-cli, php-devel, gnupg

Provides: php-pear(Console_Getopt) = %{getoptver}
Provides: php-pear(Archive_Tar) = %{arctarver}
Provides: php-pear(PEAR) = %{version}
Provides: php-pear(Structures_Graph) = %{structver}
Provides: php-pear(XML_RPC) = %{xmlrpcver}
Provides: php-pear(XML_Util) = %{xmlutil}
Obsoletes: php-pear-XML-Util <= %{xmlutil}
Provides:  php-pear-XML-Util = %{xmlutil}-%{release}
Provides: php-pear(Net_Socket) = 1.0.10
Provides: php-pear(Auth_SASL) = 1.0.4
Provides: php-pear(DB) = 1.7.13
Provides: php-pear(HTTP) = 1.4.1
Provides: php-pear(Net_SMTP) = 1.5.2
Provides: php-pear(Mail) = 1.2.0
Provides: php-pear(Net_UserAgent_Detect) = 2.5.2
Provides: php-pear(XML_Parser) = 1.3.4
Provides: php-pear(eSystem) = %{esystemver}
Provides: php-pear(eFilesyste) = %{efilever}
Provides: php-pear(eGetopt) = %{ogetoptver}
Requires:  php-cli >= 5.1.0-1


%description
PEAR is a framework and distribution system for reusable PHP
components.  This package contains the basic PEAR components.

%prep
%setup -cT

# Create a usable PEAR directory (used by install-pear.php)
for archive in %{SOURCE0} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE24} \
		%{SOURCE100} %{SOURCE101} %{SOURCE102} \
		%{SOURCE103} %{SOURCE104} %{SOURCE105} \
		%{SOURCE106} %{SOURCE107} %{SOURCE108} \
		%{SOURCE109} %{SOURCE110} %{SOURCE111}
do
    tar xzf  $archive --strip-components 1 || tar xzf  $archive --strip-path 1
    file=${archive##*/}
    [ -f LICENSE ] && mv LICENSE LICENSE-${file%%-*}
    [ -f README ]  && mv README  README-${file%%-*}
done
tar xzf %{SOURCE24} package.xml
mv package.xml XML_Util.xml

# dos format to unix
find . -type f -exec perl -pi -e 's/\r\n/\n/g' {} \;

%patch0 -p1
install -m 644 %{SOURCE10000} ./AliasFunc.php

# apply patches on used PEAR during install
# -- no patch

%build
# This is an empty build section.

%install
rm -rf $RPM_BUILD_ROOT

export PHP_PEAR_SYSCONF_DIR=%{_sysconfdir}/php.d
export PHP_PEAR_SIG_KEYDIR=%{_sysconfdir}/php.d/pearkeys
export PHP_PEAR_SIG_BIN=%{_bindir}/gpg
export PHP_PEAR_INSTALL_DIR=%{peardir}

# 1.4.11 tries to write to the cache directory during installation
# so it's not possible to set a sane default via the environment.
# The ${PWD} bit will be stripped via relocate.php later.
export PHP_PEAR_CACHE_DIR=%{_localstatedir}/lib/php/pear/cache
export PHP_PEAR_TEMP_DIR=%{_localstatedir}/lib/php/tmp
export PHP_PEAR_DOWNLOAD_DIR=%{_localstatedir}/lib/php/pear/download

install -d $RPM_BUILD_ROOT%{peardir} \
           $RPM_BUILD_ROOT${PHP_PEAR_CACHE_DIR} \
           $RPM_BUILD_ROOT%{peardir}/.pkgxml \
           $RPM_BUILD_ROOT%{_sysconfdir}/rpm \
           $RPM_BUILD_ROOT${PHP_PEAR_SYSCONF_DIR}/pearkeys \
           $RPM_BUILD_ROOT${PHP_PEAR_DOWNLOAD_DIR}

export INSTALL_ROOT=$RPM_BUILD_ROOT

%{_bindir}/php -n %{?cliopt} -dmemory_limit=32M -dshort_open_tag=0 -dsafe_mode=0 \
         -derror_reporting=E_ALL -ddetect_unicode=0 \
      %{SOURCE1} -d %{peardir} \
                 -c %{_sysconfdir}/php.d \
                 -b %{_bindir} \
                 %{SOURCE0} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE24} %{SOURCE20} \
                 %{SOURCE100} %{SOURCE101} %{SOURCE102} %{SOURCE103} %{SOURCE104} \
                 %{SOURCE105} %{SOURCE106} %{SOURCE107} %{SOURCE108} %{SOURCE109}

# Replace /usr/bin/* with simple scripts:
install -m 755 %{SOURCE10} $RPM_BUILD_ROOT%{_bindir}/pear
install -m 755 %{SOURCE11} $RPM_BUILD_ROOT%{_bindir}/pecl
install -m 755 %{SOURCE12} $RPM_BUILD_ROOT%{_bindir}/peardev

# Sanitize the pear.conf
%{_bindir}/php -n %{?cliopt} %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/php.d/pear.conf $RPM_BUILD_ROOT | 
  %{_bindir}/php -n %{?cliopt} %{SOURCE2} php://stdin $PWD > new-pear.conf
%{_bindir}/php -n %{?cliopt} %{SOURCE3} new-pear.conf ext_dir |
  %{_bindir}/php -n %{?cliopt} %{SOURCE3} php://stdin http_proxy > $RPM_BUILD_ROOT%{_sysconfdir}/php.d/pear.conf

%{_bindir}/php -r "print_r(unserialize(substr(file_get_contents('$RPM_BUILD_ROOT%{_sysconfdir}/php.d/pear.conf'),17)));"

install -m 644 -c %{SOURCE4} LICENSE-XML_RPC

install -m 644 -c %{SOURCE13} \
           $RPM_BUILD_ROOT%{_sysconfdir}/rpm/macros.pear

install -m 644 %{SOURCE10000} $RPM_BUILD_ROOT%{peardir}/AliasFunc.php

# apply patches on installed PEAR tree
pushd $RPM_BUILD_ROOT%{peardir} 
# -- no patch
popd

# Why this file here ?
rm -rf $RPM_BUILD_ROOT/.depdb* $RPM_BUILD_ROOT/.lock $RPM_BUILD_ROOT/.channels $RPM_BUILD_ROOT/.filemap

# Need for re-registrying XML_Util
install -m 644 XML_Util.xml $RPM_BUILD_ROOT%{peardir}/.pkgxml/

%check
# Check that no bogus paths are left in the configuration, or in
# the generated registry files.
grep $RPM_BUILD_ROOT $RPM_BUILD_ROOT%{_sysconfdir}/php.d/pear.conf && exit 1
grep %{_libdir} $RPM_BUILD_ROOT%{_sysconfdir}/php.d/pear.conf && exit 1
grep '"/tmp"' $RPM_BUILD_ROOT%{_sysconfdir}/php.d/pear.conf && exit 1
grep /usr/local $RPM_BUILD_ROOT%{_sysconfdir}/php.d/pear.conf && exit 1
grep -rl $RPM_BUILD_ROOT $RPM_BUILD_ROOT && exit 1


%clean
rm -rf $RPM_BUILD_ROOT
rm new-pear.conf


%triggerpostun -- php-pear-XML-Util
# re-register extension unregistered during postun of obsoleted php-pear-XML-Util
%{_bindir}/pear install --nodeps --soft --force --register-only %{pear_xmldir}/XML_Util.xml >/dev/null || :

%post
if test ! -d /var/lib/php/tmp; then
    mkdir -p /var/lib/php/tmp
    chmod 755 /var/lib/php/tmp
    chown nobody.nobody /var/lib/php/tmp
fi

%files
%defattr(-,root,root,-)
%{peardir}
%{_bindir}/*
%config(noreplace) %{_sysconfdir}/php.d/pear.conf
%config %{_sysconfdir}/rpm/macros.pear
%dir %{_sysconfdir}/php.d/pearkeys
%dir %{_localstatedir}/lib/php/pear
%dir %{_localstatedir}/lib/php/pear/cache
%dir %{_localstatedir}/lib/php/pear/download

%changelog
* Tue May 10 2011 JoungKyun.Kim <http://oops.org> 203:1.9.2-3.fc16%{?dist}
- update
